import org.objectweb.fractal.api.Component;
import org.objectweb.fractal.api.Interface;
import org.objectweb.fractal.api.NoSuchInterfaceException;
import org.objectweb.fractal.api.control.LifeCycleController;
import org.objectweb.fractal.api.control.BindingController;
import org.objectweb.fractal.api.control.ContentController;
import org.objectweb.fractal.api.factory.GenericFactory;
import org.objectweb.fractal.api.type.TypeFactory;
import org.objectweb.fractal.api.type.ComponentType;
import org.objectweb.fractal.api.type.InterfaceType;

import org.objectweb.fractal.util.Fractal;

import org.objectweb.fractal.rmi.registry.NamingService;
import org.objectweb.fractal.rmi.registry.Registry;

import java.util.Map;
import java.util.HashMap;
import java.util.Set;
import java.util.Iterator;
import java.util.List;
import java.util.ArrayList;

public class Configurator {

  public static void main (String[] args) throws Exception {
    System.setSecurityManager(new SecurityManager());
    NamingService ns = Registry.getRegistry();
    Component boot = ns.lookup("boot");
    Component comp = ns.lookup("comanche");

    Component logger = getComponent(comp, "Comanche/back-end/logger");
    Component errorHandler = getComponent(comp, "Comanche/back-end/handler/error-handler");

    Component newLogger;
    Component newErrorHandler;

    // TODO creer les composants newLogger et newErrorHandler

    System.err.println("replacing logger component...");
    replaceComponent(logger, newLogger);
    System.err.println("replacing error-handler component...");
    replaceComponent(errorHandler, newErrorHandler);
    System.err.println("reconfiguration done.");
    System.exit(0);
  }

  public static Component getComponent (Component c, String name) throws Exception {
    // TODO
  }

  public static void replaceComponent (Component component, Component newComponent) throws Exception {
    // TODO 1 save "component" execution state, and then stop it

    // TODO 2 save execution state of the parent component(s) of "component", and then stop them

    // TODO 3 save bindings FROM "component", and then remove them

    // TODO 4 save bindings TO "component", and then remove them

    // TODO 5 remove "component" from its parent component(s)

    // TODO 5' add "newComponent" to the parent component(s)

    // TODO 4' restore the bindings TO "newComponent"

    // TODO 3' restore the bindings FROM "newComponent"

    // TODO 2' restore the execution state of the parent component(s)

    // TODO 1' restore the execution state of "component"
  }

  // returns the client interfaces that are bound to the "itf" server interface

  private static Set getFcClientItfsBoundTo (Interface itf) throws Exception {
    return org.objectweb.fractal.julia.control.binding.Util.getFcClientItfsBoundTo(itf);
  }
}
